%compute emperical multinomials for each item
load ml_med1_weak
num_items = size(train_data,2);
num_users = size(train_data,1);
%vote distribution per item
for i=1:num_votes
  rd(i,:) = sum(train_data==i)+1;
end
norm=sum(rd);
uni=rd./max(repmat(norm,num_votes,1),eps);
uni=full(uni);


load ml1_10
perm=randperm(5000);
u=perm(1:100);
figure(1); image(mu(:,u)*128); colormap gray(128);
eta=mean(mu,2);

%Compute percomponent distributions, and KL from emperical distro
KL=zeros(1,num_items);
umu=eta;
for y=1:num_items
  r=squeeze(rho(:,y,:));
  Pvky(:,:,y)=exp(r)./repmat(sum(exp(r),1),[5,1]);
  Pvk=Pvky(:,:,1);
  Pe=zeros(V,1);
  for d=0:(2^10-1);
    b=(dec2bin(d,10)-48)';
    temp = prod(Pvk(:,find(b)),2);
    temp=temp/sum(temp);
    Pe=Pe+temp * prod(b.*umu + (1-b).*(1-umu));
    ssample=ssample+sample;
  end
  Pep=Pe;
  KL(y)=sum(uni(:,y).*(log(uni(:,y))-log(Pep)));
  [y,KL(y)]
end


figure(9); hist(KL

figure(2); image(Pvk'*128); colormap gray(128);
Pvk=Pvky(:,:,2427);

%Compute sampled approximation to true product distribution
%num_samples=200;
%Ps=zeros(V,1);
%ssample = zeros(K,1);
%for s=1:num_samples;
%  sample=(rand(K,1)>(1-umu));
%  temp = prod(Pvk(:,find(sample)),2);
%  temp=temp/sum(temp);
%  Ps=Ps+temp * prod(sample.*umu + (1-sample).*(1-umu));
%  ssample=ssample+sample;
%end
%Ps = Ps/sum(Ps)

%Compute exact distribution mixing with eta, compare to emperical
umu=eta;
Pe=zeros(V,1);
for d=0:(2^10-1);
  b=(dec2bin(d,10)-48)';
  temp = prod(Pvk(:,find(b)),2);
  temp=temp/sum(temp);
  Pe=Pe+temp * prod(b.*umu + (1-b).*(1-umu));
  ssample=ssample+sample;
end
Pep=Pe
figure(3); subplot(1,2,1); image([Pep]*128); colormap gray(128); subplot(1,2,2);  image(uni(:,2427)*128); colormap gray(128);

%Compute exact distribution
Pe=zeros(V,length(u));
for i=1:100
  umu=mu(:,u(i));
  for d=0:(2^10-1);
    b=(dec2bin(d,10)-48)';
    temp = prod(Pvk(:,find(b)),2);
    temp=temp/sum(temp);
    Pe(:,i)=Pe(:,i)+temp * prod(b.*umu + (1-b).*(1-umu));
    ssample=ssample+sample;
  end
end
Peu=Pe 
figure(4);  image(Peu*128); colormap gray(128);


hist(KL/log(2),50)
xlabel('KL Divergence from Exact to Approximate Posterior');
ylabel('Number of Users');

hist(KL_model_emperical/log(2),50);
xlabel('KL Divergence from Emperical to Model Rating Distribution');
ylabel('Number of Items');